| Home | Libraries | People | FAQ | More

## Struct right

boost::proto::functional::right — A callable PolymorphicFunctionObject that is equivalent to the `proto::right()` function.

## Synopsis

    // In header: <boost/proto/traits.hpp>

    struct right :  proto::callable {
      // member classes/structs/unions
      template<typename This, typename Expr>
      struct result<This(Expr)> :  proto::result_of::right< Expr > {
      };

      // public member functions
      template<typename Expr>
        typename proto::result_of::right< Expr & >::type operator()(Expr &) const;
      template<typename Expr>
        typename proto::result_of::right< Expr const & >::type
        operator()(Expr const &) const;
    };

## Description

### `right` public member functions

1.     template<typename Expr>
         typename proto::result_of::right< Expr & >::type
         operator()(Expr & expr) const;

   Return the right child of the given binary expression.

   Parameters:

   `expr` | The expression node.

   Requires: | `proto::is_expr<Expr>::value` is `true` `2 == Expr::proto_arity::value`
   Returns: | `proto::right(expr)`
   Throws: | Will not throw.

2.     template<typename Expr>
         typename proto::result_of::right< Expr const & >::type
         operator()(Expr const & expr) const;